<?php
/**
 * jtlwawi_connector/dbeS/Artikel.php
 * JTL-Wawi Connector for VirtueMart
 *
 * Es gelten die Nutzungs- und Lizenzhinweise unter http://www.jtl-software.de/jtlwawi.php
 *
 * @author JTL-Software <thomas@jtl-software.de>
 * @copyright 2007, JTL-Software
 * @link http://jtl-software.de/jtlwawi.php
 * @version v1.0 / 24.06.07
*/
require_once("syncinclude.php");

$return=3;
if (auth())
{
	if (intval($_POST["action"]) == 1 && intval($_POST['KeyArtikel']))
	{
		$return = 0;
		//hole einstellungen
		$einstellungen = getEinstellungen();

		$artikel->kArtikel = realEscape($_POST["KeyArtikel"]);
		$artikel->cArtNr = realEscape($_POST["ArtikelNo"]);
		$artikel->cName = realEscape($_POST["ArtikelName"]);
		$artikel->cBeschreibung = realEscape($_POST["ArtikelBeschreibung"]);
		$artikel->fVKBrutto = realEscape($_POST["ArtikelVKBrutto"]);
		$artikel->fVKNetto = realEscape($_POST["ArtikelVKNetto"]);
		$artikel->fMwSt = realEscape($_POST["ArtikelMwSt"]);
		$artikel->cAnmerkung = realEscape($_POST["ArtikelAnmerkung"]);
		$artikel->nLagerbestand = max(realEscape($_POST["ArtikelLagerbestand"]),0);
		$artikel->cEinheit = realEscape($_POST["ArtikelEinheit"]);
		$artikel->nMindestbestellmaenge = realEscape($_POST["ArtikelMindBestell"]);
		$artikel->cBarcode = realEscape($_POST["ArtikelBarcode"]);
		$artikel->fVKHaendlerBrutto = realEscape($_POST["ArtikelVKHaendlerBrutto"]);
		$artikel->fVKHaendlerNetto = realEscape($_POST["ArtikelVKHaendlerNetto"]);
		$artikel->cTopArtikel = realEscape($_POST["TopAngebot"]);
		$artikel->fGewicht = realEscape($_POST["Gewicht"]);
		$artikel->cNeu = realEscape($_POST["Neu"]);
		$artikel->cKurzBeschreibung = realEscape($_POST["ArtikelKurzBeschreibung"]);
		$artikel->fUVP = realEscape($_POST["ArtikelUVP"]);
		$artikel->cHersteller = realEscape($_POST["Hersteller"]);

		//update oder insert?
		$product_id = getFremdArtikel($artikel->kArtikel);
		if ($product_id>0)
		{
			//update
			//KategorieArtikel lschen
			eS_execute_query("delete from ".DBPVM."product_category_xref where product_id=".$product_id);

			//evtl. neuer Hersteller?
			$manufacturers_id = holeHerstellerId($artikel->cHersteller);

			//mwst holen
			$tax_rate_id = holeMwSt($artikel->fMwSt);

			eS_execute_query("update ".DBPVM."product set
									product_sku=\"".$artikel->cArtNr."\",
									product_s_desc=\"".$artikel->cKurzBeschreibung."\",
									product_desc=\"".$artikel->cBeschreibung."\",
									product_publish=\"Y\",
									product_weight=\"".$artikel->fGewicht."\",
									product_weight_uom=\"kg\",
									product_in_stock=\"".$artikel->nLagerbestand."\",
									product_availability=\"".$einstellungen->liefertermin."\",
									product_special=\"".$artikel->cTopArtikel."\",
									product_name=\"".$artikel->cName."\",
									product_tax_id=\"".$tax_rate_id."\",
									product_unit=\"".$artikel->cEinheit."\"
								where
									vendor_id=".VENDOR_ID." and
									product_id=".$product_id);

			eS_execute_query("delete from ".DBPVM."product_mf_xref where  product_id=".$product_id);
			eS_execute_query("insert into ".DBPVM."product_mf_xref (product_id, manufacturer_id) values($product_id,$manufacturers_id)");
			//kundengrp preise
			insertPreise($product_id);
		}
		else
		{
			//insert
			//evtl. neuer Hersteller?
			$manufacturers_id = holeHerstellerId($artikel->cHersteller);

			//mwst holen
			$tax_rate_id = holeMwSt($artikel->fMwSt);

			eS_execute_query("insert into ".DBPVM."product (product_sku, product_s_desc, product_desc, product_publish, product_weight, product_weight_uom,product_in_stock, product_availability, product_special, product_name, product_tax_id, product_unit, vendor_id) values (\"".$artikel->cArtNr."\",\"".$artikel->cKurzBeschreibung."\",\"".$artikel->cBeschreibung."\",\"Y\",\"".$artikel->fGewicht."\",\"kg\",\"".$artikel->nLagerbestand."\",\"".$einstellungen->liefertermin."\",\"".$artikel->cTopArtikel."\",\"".$artikel->cName."\",\"".$tax_rate_id."\",\"".$artikel->cEinheit."\",".VENDOR_ID.")");
			eS_execute_query("insert into ".DBPVM."product_mf_xref (product_id, manufacturer_id) values($product_id,$manufacturers_id)");

			//hole id
			$query = eS_execute_query("select LAST_INSERT_ID()");
			$product_id_arr = mysql_fetch_row($query);
			if ($product_id_arr[0]>0)
			{
				//mssen Preise in spezielle tabellen?
				$product_id=$product_id_arr[0];
				insertPreise($product_id_arr[0]);
				setMappingArtikel($artikel->kArtikel,$product_id_arr[0]);
			}
			else
			{
				//Fehler aufgetreten
				$return=1;
			}
		}
 	}
	else
		$return=5;

//	if (intval($_POST["action"]) == 3 && intval($_POST['KeyArtikel']))
//	{
//		$product_id = getFremdArtikel(intval($_POST['KeyArtikel']));
//		if ($product_id>0)
//                        eS_execute_query("update ".DBPVM."product set product_publish=\"N\" where vendor_id=".VENDOR_ID." and product_id=".$product_id);
//		$return = 0;
//	}
//   gelschte Artikel dauerhaft lschen

         if (intval($_POST["action"]) == 3 && intval($_POST['KeyArtikel']))
	{
		$product_id = getFremdArtikel(intval($_POST['KeyArtikel']));
		if ($product_id>0)
                    eS_execute_query("delete from ".DBPVM."product where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_attribute where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_attribute_sku where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_category_xref where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_discount where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_download where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_files where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_mf_xref where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_price where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_product_type_xref where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_relations where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_reviews where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_type where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_type_parameter where vendor_id=".VENDOR_ID." and product_id=".$product_id);
                    eS_execute_query("delete from ".DBPVM."product_votes where vendor_id=".VENDOR_ID." and product_id=".$product_id);
		$return = 0;
         }
}

mysql_close();
echo($return);
logge($return);

function insertPreise($product_id)
{
	eS_execute_query("delete from ".DBPVM."product_price where product_id=".$product_id);
	$endKunden_arr = explode(";",$GLOBALS['einstellungen']->mappingEndkunde);
	foreach ($endKunden_arr as $shopper_group_id)
	{
		if ($shopper_group_id>0)
		{
			eS_execute_query("insert into ".DBPVM."product_price (product_id, product_price, product_currency,shopper_group_id,price_quantity_start,price_quantity_end) values ($product_id,".floatval($_POST["ArtikelVKNetto"]).",\"".$GLOBALS['einstellungen']->waehrung."\",$shopper_group_id,1,1)");
			if (intval($_POST["PAnz1"])>0)
			{
				$range=9999;
				if (intval($_POST["PAnz2"])>0)
					$range=intval($_POST["PAnz2"])-1;
				eS_execute_query("insert into ".DBPVM."product_price (product_id, product_price, product_currency,shopper_group_id,price_quantity_start,price_quantity_end) values ($product_id,".floatval($_POST["PPreis1"]).",\"".$GLOBALS['einstellungen']->waehrung."\",$shopper_group_id,".intval($_POST["PAnz1"]).",$range)");
			}
			if (intval($_POST["PAnz2"])>0)
			{
				$range=9999;
				if (intval($_POST["PAnz3"])>0)
					$range=intval($_POST["PAnz3"])-1;
				eS_execute_query("insert into ".DBPVM."product_price (product_id, product_price, product_currency,shopper_group_id,price_quantity_start,price_quantity_end) values ($product_id,".floatval($_POST["PPreis2"]).",\"".$GLOBALS['einstellungen']->waehrung."\",$shopper_group_id,".intval($_POST["PAnz2"]).",$range)");
			}
			if (intval($_POST["PAnz3"])>0)
			{
				$range=9999;
				if (intval($_POST["PAnz4"])>0)
					$range=intval($_POST["PAnz4"])-1;
				eS_execute_query("insert into ".DBPVM."product_price (product_id, product_price, product_currency,shopper_group_id,price_quantity_start,price_quantity_end) values ($product_id,".floatval($_POST["PPreis3"]).",\"".$GLOBALS['einstellungen']->waehrung."\",$shopper_group_id,".intval($_POST["PAnz3"]).",$range)");
			}
			if (intval($_POST["PAnz4"])>0)
			{
				$range=9999;
				if (intval($_POST["PAnz5"])>0)
					$range=intval($_POST["PAnz5"])-1;
				eS_execute_query("insert into ".DBPVM."product_price (product_id, product_price, product_currency,shopper_group_id,price_quantity_start,price_quantity_end) values ($product_id,".floatval($_POST["PPreis4"]).",\"".$GLOBALS['einstellungen']->waehrung."\",$shopper_group_id,".intval($_POST["PAnz4"]).",$range)");
			}
			if (intval($_POST["PAnz5"])>0)
			{
				$range=9999;
				eS_execute_query("insert into ".DBPVM."product_price (product_id, product_price, product_currency,shopper_group_id,price_quantity_start,price_quantity_end) values ($product_id,".floatval($_POST["PPreis5"]).",\"".$GLOBALS['einstellungen']->waehrung."\",$shopper_group_id,".intval($_POST["PAnz5"]).",$range)");
			}
		}
	}
	$haendlerKunden_arr = explode(";",$GLOBALS['einstellungen']->mappingHaendlerkunde);
	foreach ($haendlerKunden_arr as $shopper_group_id)
	{
		if ($shopper_group_id>=0)
		{
			eS_execute_query("insert into ".DBPVM."product_price (product_id, product_price, product_currency,shopper_group_id,price_quantity_start,price_quantity_end) values ($product_id,".floatval($_POST["ArtikelVKHaendlerNetto"]).",\"".$GLOBALS['einstellungen']->waehrung."\",$shopper_group_id,1,1)");
			if (intval($_POST["HAnz1"])>0)
			{
				$range=9999;
				if (intval($_POST["HAnz2"])>0)
					$range=intval($_POST["HAnz2"])-1;
				eS_execute_query("insert into ".DBPVM."product_price (product_id, product_price, product_currency,shopper_group_id,price_quantity_start,price_quantity_end) values ($product_id,".floatval($_POST["HPreis1"]).",\"".$GLOBALS['einstellungen']->waehrung."\",$shopper_group_id,".intval($_POST["HAnz1"]).",$range)");
			}
			if (intval($_POST["HAnz2"])>0)
			{
				$range=9999;
				if (intval($_POST["HAnz3"])>0)
					$range=intval($_POST["HAnz3"])-1;
				eS_execute_query("insert into ".DBPVM."product_price (product_id, product_price, product_currency,shopper_group_id,price_quantity_start,price_quantity_end) values ($product_id,".floatval($_POST["HPreis2"]).",\"".$GLOBALS['einstellungen']->waehrung."\",$shopper_group_id,".intval($_POST["HAnz2"]).",$range)");
			}
			if (intval($_POST["HAnz3"])>0)
			{
				$range=9999;
				if (intval($_POST["HAnz4"])>0)
					$range=intval($_POST["HAnz4"])-1;
				eS_execute_query("insert into ".DBPVM."product_price (product_id, product_price, product_currency,shopper_group_id,price_quantity_start,price_quantity_end) values ($product_id,".floatval($_POST["HPreis3"]).",\"".$GLOBALS['einstellungen']->waehrung."\",$shopper_group_id,".intval($_POST["HAnz3"]).",$range)");
			}
			if (intval($_POST["HAnz4"])>0)
			{
				$range=9999;
				if (intval($_POST["HAnz5"])>0)
					$range=intval($_POST["HAnz5"])-1;
				eS_execute_query("insert into ".DBPVM."product_price (product_id, product_price, product_currency,shopper_group_id,price_quantity_start,price_quantity_end) values ($product_id,".floatval($_POST["HPreis4"]).",\"".$GLOBALS['einstellungen']->waehrung."\",$shopper_group_id,".intval($_POST["HAnz4"]).",$range)");
			}
			if (intval($_POST["HAnz5"])>0)
			{
				$range=9999;
				eS_execute_query("insert into ".DBPVM."product_price (product_id, product_price, product_currency,shopper_group_id,price_quantity_start,price_quantity_end) values ($product_id,".floatval($_POST["HPreis5"]).",\"".$GLOBALS['einstellungen']->waehrung."\",$shopper_group_id,".intval($_POST["HAnz5"]).",$range)");
			}
		}
	}
}

function holeHerstellerId($cHersteller)
{
	if (strlen($cHersteller)>0)
	{
		//ex. dieser Hersteller?
		$manu = eS_execute_query("select manufacturer_id from ".DBPVM."manufacturer where mf_name=\"".$cHersteller."\"",1);
		if ($manu->manufacturer_id>0)
			return $manu->manufacturer_id;
		else
		{
			//erstelle diesen Hersteller
			eS_execute_query("insert into ".DBPVM."manufacturer (mf_name) values (\"".$cHersteller."\")");
			$query = eS_execute_query("select LAST_INSERT_ID()");
			$manu_id_arr = mysql_fetch_row($query);
			return $manu_id_arr[0];
		}
	}
	return 0;
}

function holeMwSt($fMwSt)
{
	//schaue, ob eine solche Steuer bereits existiert
	$tax = eS_execute_query("select tax_rate_id from ".DBPVM."tax_rate where vendor_id=".VENDOR_ID." and tax_rate=".($fMwSt/100.0),1);
	if ($tax->tax_rate_id>0)
		return $tax->tax_rate_id;
	else
	{
		$vendor = eS_execute_query("select * from ".DBPVM."vendor where vendor_id=".VENDOR_ID,1);
		//erstelle diese steuer
		eS_execute_query("insert into ".DBPVM."tax_rate (tax_rate,vendor_id,tax_state,tax_country) values (".$fMwSt."/100,".VENDOR_ID.",\"".$vendor->vendor_state."\",\"".$vendor->vendor_country."\")");
		$query = eS_execute_query("select LAST_INSERT_ID()");
		$manu_id_arr = mysql_fetch_row($query);
		return $manu_id_arr[0];
	}
}


?>