<?php
/**
 * jtlwawi_connector/dbeS/Attribute.php
 * JTL-Wawi Connector for VirtueMart
 * 
 * Es gelten die Nutzungs- und Lizenzhinweise unter http://www.jtl-software.de/jtlwawi.php
 * 
 * @author JTL-Software <thomas@jtl-software.de>
 * @copyright 2007, JTL-Software
 * @link http://jtl-software.de/jtlwawi.php
 * @version v1.0 / 24.06.07
*/
require_once("syncinclude.php");

$return=3;
if (auth())
{
	if (intval($_POST["action"]) == 1 && intval($_POST['KeyAttribut']))
	{
		$return = 0;
		
		$Attribut->product_id = getFremdArtikel(intval($_POST["KeyArtikel"]));
		$Attribut->name = $_POST["Name"];
		$Attribut->content = $_POST["StringWert"];
		if (strlen($_POST["TextWert"])>0)
			$Attribut->content = $_POST["TextWert"];
		attributBearbeiten ($Attribut);
	}
}

mysql_close();
echo($return);
logge($return);

//Attribut wird verarbeitet / in DB insertet
function attributBearbeiten ($Attribut)
{
	if ($Attribut->product_id>0)
	{
		switch (strtolower($Attribut->name))
		{
			case 'rabatt':
				if ($Attribut->content)
				{
					$is_percent=0;
					$Attribut->content=trim($Attribut->content);
					if ($Attribut->content{strlen($Attribut->content)-1}=="%")
					{
						$is_percent=1;
						$Attribut->content=substr($Attribut->content,0,strlen($Attribut->content)-1);
					}
					
					//schau, ob so ein sonderpreis bereits existiert
					$sp = eS_execute_query("select * from ".DBPVM."product_discount where start_date=0 and end_date=0 and amount=$Attribut->content and is_percent=".$is_percent,1);
					if ($sp->discount_id>0)
					{
						eS_execute_query("update ".DBPVM."product set product_discount_id=".$sp->discount_id." where product_id=$Attribut->product_id and vendor_id=".VENDOR_ID);
					}
					else 
					{
						eS_execute_query("insert into ".DBPVM."product_discount (amount,is_percent) values(".$Attribut->content.",".$is_percent.")");
						$query = eS_execute_query("select LAST_INSERT_ID()");
						$id = mysql_fetch_row($query);
						eS_execute_query("update ".DBPVM."product set product_discount_id=".$id[0]." where product_id=$Attribut->product_id and vendor_id=".VENDOR_ID);
					}
				}
				break;
			case 'url':
				if ($Attribut->content)
					eS_execute_query("update ".DBPVM."product set product_url=\"".$Attribut->content."\" where product_id=$Attribut->product_id and vendor_id=".VENDOR_ID);
				break;
			case 'freifeldattribute':
				if ($Attribut->content)
					eS_execute_query("update ".DBPVM."product set custom_attribute=\"".$Attribut->content."\" where product_id=$Attribut->product_id and vendor_id=".VENDOR_ID);
				break;				
			case 'lieferfrist':
				if ($Attribut->content)
					eS_execute_query("update ".DBPVM."product set product_availability=\"".$Attribut->content."\" where product_id=$Attribut->product_id and vendor_id=".VENDOR_ID);
				break;	
			case 'lnge':
				if ($Attribut->content)
					eS_execute_query("update ".DBPVM."product set product_length=\"".str_replace(",",".",$Attribut->content)."\" where product_id=$Attribut->product_id and vendor_id=".VENDOR_ID);
				break;
			case 'breite':
				if ($Attribut->content)
					eS_execute_query("update ".DBPVM."product set product_width=\"".str_replace(",",".",$Attribut->content)."\" where product_id=$Attribut->product_id and vendor_id=".VENDOR_ID);
				break;
			case 'hhe':
				if ($Attribut->content)
					eS_execute_query("update ".DBPVM."product set product_height=\"".str_replace(",",".",$Attribut->content)."\" where product_id=$Attribut->product_id and vendor_id=".VENDOR_ID);
				break;
			case 'lngenma':
				if ($Attribut->content)
					eS_execute_query("update ".DBPVM."product set product_lwh_uom=\"".$Attribut->content."\" where product_id=$Attribut->product_id and vendor_id=".VENDOR_ID);
				break;
			case 'gewichtsma':
				if ($Attribut->content)
					eS_execute_query("update ".DBPVM."product set product_weight_uom=\"".$Attribut->content."\" where product_id=$Attribut->product_id and vendor_id=".VENDOR_ID);
				break;
			case 'vpe':
				if ($Attribut->content)
				{
					$tmp=explode(",",$Attribut->content);
					$x=0;
					if ($tmp[0] && $tmp[1])
						$x=$tmp[1]*65536+$tmp[0];
					eS_execute_query("update ".DBPVM."product set product_packaging=".$x." where product_id=$Attribut->product_id and vendor_id=".VENDOR_ID);
				}
				break;
			default:
				if ($Attribut->content && ES_ATTRIBUTE_AN_BESCHREIBUNG_ANHAENGEN==1)
				{
					//an description anhngen
					$cur_query = eS_execute_query("select product_desc from ".DBPVM."product where product_id=".$Attribut->product_id." and vendor_id=".VENDOR_ID);
					$product_desc = mysql_fetch_row($cur_query);
					$desc = $product_desc[0]."<br><b>".$Attribut->name."</b>: ".$Attribut->content;
					eS_execute_query("update ".DBPVM."product set product_desc=\"".$desc."\" where product_id=".$Attribut->product_id." and vendor_id=".VENDOR_ID);
				}
				break;
		}
	}
}


?>