<?php
/**
 * jtlwawi_connector/dbeS/VariationsWert.php
 * JTL-Wawi Connector for VirtueMart
 * 
 * Es gelten die Nutzungs- und Lizenzhinweise unter http://www.jtl-software.de/jtlwawi.php
 * 
 * @author JTL-Software <thomas@jtl-software.de>
 * @copyright 2007, JTL-Software
 * @link http://jtl-software.de/jtlwawi.php
 * @version v1.0 / 24.06.07
*/
require_once("syncinclude.php");

$return=3;
if (auth())
{
	if (intval($_POST["action"]) == 1 && intval($_POST['KeyEigenschaftWert']))
	{
		$return = 0;
		
		$EigenschaftWert->kEigenschaftWert = intval($_POST["KeyEigenschaftWert"]);
		$EigenschaftWert->kEigenschaft = intval($_POST["KeyEigenschaft"]);
		$EigenschaftWert->fAufpreis = floatval($_POST["Aufpreis"]);
		$EigenschaftWert->cName = realEscape($_POST["Name"]);
		$EigenschaftWert->nSort = intval($_POST["Sort"]);
		$EigenschaftWert->nLager = intval($_POST["Lager"]);
		$EigenschaftWert->cArtikelNr = realEscape($_POST["ArtikelNr"]);
		$EigenschaftWert->fGewichtDiff = floatval($_POST["GewichtDiff"]);
		
		$attribute_id=getFremdEigenschaft($EigenschaftWert->kEigenschaft);
		$product_id=getFremdArtikelPerEigenschaft($EigenschaftWert->kEigenschaft);		
		$kArtikel=getEsArtikel($product_id);
		if ($attribute_id && $product_id && $kArtikel)
		{
			$varGanz=$EigenschaftWert->cName;
			if ($EigenschaftWert->fAufpreis!=0)
			{
				//hol steuer
				$steuer = eS_execute_query("select ".DBPVM."tax_rate.tax_rate from ".DBPVM."tax_rate, ".DBPVM."product where ".DBPVM."tax_rate.tax_rate_id=".DBPVM."product.product_tax_id and ".DBPVM."product.product_id=".$product_id,1);
				$plus="";
				if ($EigenschaftWert->fAufpreis>0)
					$plus="+";
				$varGanz.="[".$plus.($EigenschaftWert->fAufpreis/(1+$steuer->tax_rate))."]";
			}
			
			
			$attribute_value_id=setPreVariationswert($EigenschaftWert->cName, $product_id, $attribute_id, $varGanz);
			setMappingEigenschaftsWert($EigenschaftWert->kEigenschaftWert, $attribute_value_id, $kArtikel);
			
			//baue attribute im product
			setAttributeInProduct($product_id);
		}
 	}
	else
		$return=5;
}

mysql_close();
echo($return);
logge($return);

function setAttributeInProduct($product_id)
{
	$varString="";
	$variationen = eS_execute_query("select * from jtlwawi_mvariation where vendor_id=".VENDOR_ID." and product_id=".$product_id,2);
	foreach ($variationen as $o => $variation)
	{
		$varwerte = eS_execute_query("select * from jtlwawi_mvariationswert where vendor_id=".VENDOR_ID." and attribute_id=".$variation->attribute_id,2);
		foreach ($varwerte as $i => $varwert)
		{
			if ($i==0)
			{
				$varString.=$variation->attribute_name;
			}
			$varString.=",".$varwert->attribute_value_ganz;
		}
		if (is_array($varwerte) && count($varwerte)>0)
			$varString.=";";
	}
	if (strlen($varString)>1)
		eS_execute_query("update ".DBPVM."product set attribute=\"".substr($varString,0,strlen($varString)-1)."\" where vendor_id=".VENDOR_ID." and product_id=".$product_id);
}
?>