<?php
/**
 * jtlwawi_connector/dbeS/syncinclude.php
 * JTL-Wawi Connector for VirtueMart
 * 
 * Es gelten die Nutzungs- und Lizenzhinweise unter http://www.jtl-software.de/jtlwawi.php
 * 
 * @author JTL-Software <thomas@jtl-software.de>
 * @copyright 2007, JTL-Software
 * @link http://jtl-software.de/jtlwawi.php
 * @version v1.0 / 24.06.07
*/
define ('VENDOR_ID',1);

define ('_VALID_MOS',1);
define ('ES_ENABLE_LOGGING',0);
define ('ES_ATTRIBUTE_AN_BESCHREIBUNG_ANHAENGEN',1);

require( '../../../globals.php' );
require_once( '../../../configuration.php' );
require_once( '../../../includes/joomla.php' );
if (file_exists($mosConfig_absolute_path. "/administrator/components/com_virtuemart/virtuemart.cfg.php"))
	require_once( $mosConfig_absolute_path. "/administrator/components/com_virtuemart/virtuemart.cfg.php" );

//DB Prefix bestimmen
define( 'VMP', "vm_");
define( 'DBP', $database->getPrefix() );
define( 'DBPVM', DBP.VMP);

function eS_execute_query($query, $ret=3, $echo=0)
{
	if ($echo)
		echo($query);

	if (!$query)
		return false;
	elseif ($ret==1)
		return mysql_fetch_object(mysql_query($query));
	elseif ($ret==2)
	{
		$obj_arr=array();
		$res = mysql_query($query);
		while ($obj = mysql_fetch_object($res))
			$obj_arr[]=$obj;
		return $obj_arr;
	}
	else
		return mysql_query($query);
}

function getEinstellungen()
{
	$einstellungen;
	$cur_query = eS_execute_query("select * from jtlwawi_einstellungen where vendor_id=".VENDOR_ID);
	while ($cur_einstellung = mysql_fetch_object($cur_query))
	{
		$einstellungen->{$cur_einstellung->cName}=$cur_einstellung->cWert;
	}
	
	//erstelle kdgrp mapping
	$mappingEndkunde_arr = explode(";",$einstellungen->mappingEndkunde);
	$mappingHaendlerkunde_arr = explode(";",$einstellungen->mappingHaendlerkunde);
	$einstellungen->stdEndkunde = $mappingEndkunde_arr[0];
	$einstellungen->stdHaendlerkunde = $mappingHaendlerkunde_arr[0];
	
	return $einstellungen;
}

/**
 * Authentifiziert die Anfrage
 *
 * @return Bool true, wenn Auth ok, sonst false
 */
function auth()
{
	return true;
	$cName = $_POST["userID"];
	$cPass = $_POST["userPWD"];

	$cur_query = eS_execute_query("select * from jtlwawi_sync where vendor_id=".VENDOR_ID);
	$loginDaten = mysql_fetch_object($cur_query);
	if ($cName == $loginDaten->cName && $cPass == $loginDaten->cPass)
		return true;

	return false;
}

/**
 * Gibt einen vardump eines Objekts aus, der sich besser loggen lsst.
 *
 * @param Object $vardump Objekt, das gedumpt werden soll
 * @param int $key Schlssel
 * @param int $level Aktuellw Tiefe
 * @param String $return Rckgabestring
 * @return String verbesserten Vardump
 */
function Dump($vardump)
{
	if (gettype($vardump)!="object" && gettype($vardump)!="array")
		$return.= $vardump;
	elseif (gettype($vardump)=="object")
	{
		foreach(get_object_vars($vardump) as $key => $value)
		{
			$return.= $key." => ".Dump($value).", ";
		}
	}
	elseif (gettype($vardump)=="array")
	{
		foreach ($vardump as $key => $value)
			$return.= $key." => ".Dump($value).", ";
	}
	if ($return{strlen($return)-2}==',')
		return substr($return,0,strlen($return)-2)." ";
	else 
		return $return;
}

/**
 * Fgt Anfhrungszeichen vorne und am Ende an, sobald die Variable nicht leer.
 *
 * @param mixed $value
 * @return $value mit Anfhrungszeichen vorne und hinten. Falls $value leer, werden diese Zeichen nicht hinzugefgt.
 */
function CSVkonform($value)
{
	if (strlen($value)>0)
		return '"'.str_replace('"','""',$value).'"';
}

function datetime2germanDate($datetime)
{
	list ($datum, $uhrzeit) = preg_split(" ",$datetime);
	list ($jahr, $monat, $tag) = preg_split ("-",$datum);
	list ($std, $min, $sec) = preg_split (":",$uhrzeit);
	return $tag.'.'.$monat.'.'.$jahr.' '.$std.':'.$min.':'.$sec;
}

function unhtmlentities($string)
{
   // replace numeric entities
   $string = preg_replace('~&#x([0-9a-f]+);~ei', 'chr(hexdec("\\1"))', $string);
   $string = preg_replace('~&#([0-9]+);~e', 'chr("\\1")', $string);
   // replace literal entities
   $trans_tbl = get_html_translation_table(HTML_ENTITIES);
   $trans_tbl = array_flip($trans_tbl);
   return strtr($string, $trans_tbl);
}

function setMappingArtikel ($eS_key, $mein_key)
{
	$eS_key = intval($eS_key);
	$mein_key = intval($mein_key);
	if ($mein_key && $eS_key)
	{
		//ist mein_key schon drin?
		$prod = eS_execute_query("select product_id from jtlwawi_martikel where vendor_id=".VENDOR_ID." and product_id=".$mein_key,1);
		if ($prod->product_id>0)
			return "";
		else 
		{
			eS_execute_query("insert into jtlwawi_martikel (product_id, kArtikel, vendor_id) values ($mein_key,$eS_key,".VENDOR_ID.")");
		}
	}
}

function setMappingKategorie ($eS_key, $mein_key)
{
	$eS_key = intval($eS_key);
	$mein_key = intval($mein_key);
	if ($mein_key && $eS_key)
	{
		//ist mein_key schon drin?
		$prod = eS_execute_query("select category_id from jtlwawi_mkategorie where vendor_id=".VENDOR_ID." and category_id=".$mein_key,1);
		if ($prod->category_id>0)
			return "";
		else 
		{
			eS_execute_query("insert into jtlwawi_mkategorie (category_id, kKategorie, vendor_id) values ($mein_key,$eS_key,".VENDOR_ID.")");
		}
	}
}

function setMappingEigenschaft ($eS_key, $mein_key, $kArtikel)
{
	$eS_key = intval($eS_key);
	$mein_key = intval($mein_key);
	if ($mein_key && $eS_key && $kArtikel)
	{
		eS_execute_query("delete from jtlwawi_mvariation where vendor_id=".VENDOR_ID." and kEigenschaft=".$eS_key." and attribute_id!=".$mein_key);
		eS_execute_query("update jtlwawi_mvariation set kEigenschaft=$eS_key, kArtikel=$kArtikel where vendor_id=".VENDOR_ID." and attribute_id=".$mein_key);
	}
}

function setMappingBestellPos ($mein_key)
{
	$mein_key = intval($mein_key);
	eS_execute_query("delete from jtlwawi_mbestellpos where order_item_id=".$mein_key);
	eS_execute_query("insert into jtlwawi_mbestellpos (order_item_id,vendor_id) values ($mein_key,".VENDOR_ID.")");
	$query = eS_execute_query("select LAST_INSERT_ID()");
	$id_arr = mysql_fetch_row($query);
	return $id_arr[0];
}

function setMappingEigenschaftsWert ($eS_key, $mein_key, $kArtikel)
{
	$eS_key = intval($eS_key);
	$mein_key = intval($mein_key);
	if ($mein_key && $eS_key)
	{
		eS_execute_query("delete from jtlwawi_mvariationswert where vendor_id=".VENDOR_ID." and kEigenschaftsWert=".$eS_key." and attribute_value_id!=".$mein_key);
		//ist mein_key schon drin?
		$prod = eS_execute_query("select attribute_value_id from jtlwawi_mvariationswert where vendor_id=".VENDOR_ID." and kArtikel=$kArtikel and attribute_value_id=".$mein_key,1);
		if ($prod->attribute_value_id>0)
			return "";
		else 
		{
			eS_execute_query("update jtlwawi_mvariationswert set kEigenschaftsWert=$eS_key, kArtikel=$kArtikel where vendor_id=".VENDOR_ID." and attribute_value_id=".$mein_key);
		}
	}
}

function getFremdArtikel($eS_key)
{
	if ($eS_key>0)
	{
		$prod = eS_execute_query("select product_id from jtlwawi_martikel where vendor_id=".VENDOR_ID." and kArtikel=".$eS_key,1);
		return $prod->product_id;
	}
	return 0;
}

function getEsArtikel($mein_key)
{
	if ($mein_key>0)
	{
		$prod = eS_execute_query("select kArtikel from jtlwawi_martikel where vendor_id=".VENDOR_ID." and product_id=".$mein_key,1);
		return $prod->kArtikel;
	}
	return 0;
}

function getFremdKategorie($eS_key)
{
	if ($eS_key>0)
	{
		$prod = eS_execute_query("select category_id from jtlwawi_mkategorie where vendor_id=".VENDOR_ID." and kKategorie=".$eS_key,1);
		return $prod->category_id;
	}
	return 0;
}

function getEsKategorie($mein_key)
{
	if ($mein_key>0)
	{
		$prod = eS_execute_query("select kKategorie from jtlwawi_mkategorie where vendor_id=".VENDOR_ID." and category_id=".$mein_key,1);
		return $prod->kKategorie;
	}
	return 0;
}

function getFremdBestellPos($eS_key)
{
	$prod = eS_execute_query("select order_item_id from jtlwawi_mbestellpos where vendor_id=".VENDOR_ID." and kBestellPos=".$eS_key,1);
	return $prod->order_item_id;
}

function getEsEigenschaft($mein_key, $kArtikel)
{
	if ($mein_key>0 && $kArtikel>0)
	{
		$prod = eS_execute_query("select kEigenschaft from jtlwawi_mvariation where vendor_id=".VENDOR_ID." and kArtikel=".$kArtikel." and attribute_id=".$eS_key,1);
		return $prod->kEigenschaft;
	}
}

function getFremdArtikelPerEigenschaft($eS_key)
{
	if ($eS_key>0)
	{
		$prod = eS_execute_query("select product_id from jtlwawi_mvariation where vendor_id=".VENDOR_ID." and kEigenschaft=".$eS_key,1);
		return $prod->product_id;
	}
	return 0;
}

function getFremdEigenschaft($eS_key)
{
	if ($eS_key>0)
	{
		$prod = eS_execute_query("select attribute_id from jtlwawi_mvariation where vendor_id=".VENDOR_ID." and kEigenschaft=".$eS_key,1);
		return $prod->attribute_id;
	}
	return 0;
}

function getEigenschaftsArtikel($eS_key)
{
	if ($eS_key>0)
	{
		$prod = eS_execute_query("select kArtikel from jtlwawi_mvariation where vendor_id=".VENDOR_ID." and kEigenschaft=".$eS_key,1);
		return $prod->kArtikel;
	}
	return 0;
}

function getEigenschaftsId($varname, $product_id)
{
	if ($product_id>0 && $varname)
	{
		$prod = eS_execute_query("select attribute_id from jtlwawi_mvariation where vendor_id=".VENDOR_ID." and product_id=$product_id and attribute_name=\"$varname\"",1);
		return $prod->attribute_id;
	}
	return 0;
}

function getEsEigenschaftswertNachName($varwertname, $product_id, $attribute_id)
{
	if ($product_id>0 && $varwertname)
	{
		$prod = eS_execute_query("select kEigenschaftsWert from jtlwawi_mvariationswert where vendor_id=".VENDOR_ID." and product_id=$product_id and (attribute_id=$attribute_id or attribute_id=0) and attribute_value=\"$varwertname\"",1);
		return $prod->kEigenschaftsWert;
	}
	return 0;
}

function getFremdEigenschaftsWert($eS_key)
{
	if ($eS_key>0)
	{
		$prod = eS_execute_query("select attribute_value_id from jtlwawi_mvariationswert where vendor_id=".VENDOR_ID." and kEigenschaftsWert=".$eS_key,1);
		return $prod->attribute_value_id;
	}
	return 0;
}

function getEsEigenschaftsWert($mein_key, $kArtikel)
{
	if ($mein_key>0 && $kArtikel>0)
	{
		$prod = eS_execute_query("select kEigenschaftsWert from jtlwawi_mvariationswert where vendor_id=".VENDOR_ID." and kArtikel=$kArtikel and attribute_value_id=".$mein_key,1);
		return $prod->kEigenschaftsWert;
	}
	return 0;
}

function setPreVariation($variationsname, $product_id)
{
	//ist diese Variation schon in der Mappingtabelle enthalten?
	$alteVariation = eS_execute_query("select * from jtlwawi_mvariation where vendor_id=".VENDOR_ID." and product_id=".$product_id." and attribute_name=\"".$variationsname."\"",1);
	if ($alteVariation->attribute_id>0)
		return $alteVariation->attribute_id;
		
	//noch nicht drin, inserten
	//hole max attribute_id
	$maxID=1;
	$maxAtt = eS_execute_query("select max(attribute_id) as maxID from jtlwawi_mvariation where vendor_id=".VENDOR_ID,1);
	$maxID+=$maxAtt->maxID;
	eS_execute_query("insert into jtlwawi_mvariation (attribute_name, vendor_id, product_id, attribute_id) values (\"".$variationsname."\",".VENDOR_ID.",$product_id,$maxID)",3);
	return $maxID;
}

function setPreVariationswert($variationswertname, $product_id, $attribute_id, $varGanz)
{
	//ist dieser Variationswert schon in der Mappingtabelle enthalten?
	$alteVariation = eS_execute_query("select * from jtlwawi_mvariationswert where vendor_id=".VENDOR_ID." and product_id=".$product_id." and attribute_value=\"".$variationswertname."\" and attribute_value_ganz=\"".$varGanz."\" and attribute_id=".$attribute_id,1);
	if ($alteVariation->attribute_value_id>0)
		return $alteVariation->attribute_value_id;
		
	//noch nicht drin, inserten
	//hole max attribute_value_id
	$maxID=1;
	$maxAtt = eS_execute_query("select max(attribute_value_id) as maxID from jtlwawi_mvariationswert where vendor_id=".VENDOR_ID,1);
	$maxID+=$maxAtt->maxID;
	eS_execute_query("insert into jtlwawi_mvariationswert (attribute_value, vendor_id, product_id, attribute_value_id, attribute_id, attribute_value_ganz) values (\"".$variationswertname."\",".VENDOR_ID.",$product_id,$maxID,$attribute_id,\"".$varGanz."\")");
	return $maxID;
}

/**
 * real mysql escape mysql escape
 * @access public
 * @param string $ausdruck Ausdruck, der escaped fr mysql werden soll
 * @return escaped expression
 */
function realEscape ($ausdruck)
{
	if (get_magic_quotes_gpc())
		return mysql_real_escape_string(stripslashes($ausdruck));
	else
		return mysql_real_escape_string($ausdruck);
}

function logExtra($entry)
{
	if (ES_ENABLE_LOGGING!=1)
		return "";
	$logfilename = "logs/".basename($_SERVER['REQUEST_URI'],".php").".log";
	$logfile = fopen($logfilename, 'a');
	fwrite($logfile,"\n[#######Extra Log##########] [".date('m.d.y H:i:s')."]\n".$entry);
	fclose($logfile);
}

function logge($return)
{
	if (ES_ENABLE_LOGGING!=1)
		return "";
	$logfilename = "logs/".basename($_SERVER['REQUEST_URI'],".php").".log";
	$logfile = fopen($logfilename, 'a');
	fwrite($logfile,"\n[".date('m.d.y H:i:s')."] - Ret: $return\n".Dump($_POST));
	fclose($logfile);
}

//get tax 4 product
function get_tax($product_tax_id)
{
	if (!$product_tax_id)
		return 0;
	//get tax class
	$tax = eS_execute_query("select * from ".DBPVM."tax_rate where tax_rate_id=".$product_tax_id." and vendor_id=".VENDOR_ID,1);
	return ($tax->tax_rate);
}

function erstelleThumbnail($quellbild,$zielbild,$breite,$hoehe,$quality=80)
{
	$im = @ImageCreateFromJPEG ($quellbild);
	if ($im)
	{
		//bild skalieren
		list($width, $height) = getimagesize($quellbild);
		$ratio = $width / $height;
		$new_width = 120;
		if ($breite>0)
			$new_width = $breite;
		$new_height = round ($new_width / $ratio);
		if ($new_height>$hoehe)
		{
			$new_height=$hoehe;
			$new_width = round ($new_height * $ratio);
		}
		$image_p = imagecreatetruecolor($new_width, $new_height);
		imagecopyresampled($image_p, $im, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
		imagejpeg($image_p, $zielbild, $quality);
		chmod ($zielbild, 0644);
	}
}

function getAufpreis($varname,$varwertname,$product_id,$shopper_group_id)
{
	if (!$product_id || !$varwertname || !$varname || !$shopper_group_id)
		return 0;
	$preis=0;
	$product = eS_execute_query("select * from ".DBPVM."product where product_id=".$product_id,1);
	if ($product->attribute)
	{
		$varBlock=explode(";",$product->attribute);
		foreach ($varBlock as $o => $varBlockI)
		{
			$varEinzeln=explode(",",trim($varBlockI));
			if (trim($varEinzeln[0])==$varname)
			{
				foreach ($varEinzeln as $i => $var)
				{
					if ($i==0)
						continue;
					$var=trim($var);
					if ($var{strlen($var)-1}=="]")
					{								
						$tmp = explode("[",$var);
						$var=$tmp[0];
						if ($var==$varwertname)
						{
							$preisBlock = str_replace("]","",$tmp[1]);
							if ($preisBlock{0}=="+")
							{
								$preis=str_replace("+","",$preisBlock);
							}
							elseif ($preisBlock{0}=="-")
							{
								$preis=str_replace("-","",$preisBlock);
								$preis*=-1;
							}
							elseif ($preisBlock{0}=="=")
							{
								$preis=str_replace("=","",$preisBlock);
								$preis=$preis-getPreis($product, $shopper_group_id);
							}
							return $preis;	
						}
					}
					else 
					{
						if ($var==$varwertname)
							return 0;
					}
				}				
			}
		}
	}
}

function getPreis($product, $kdgrp, $brutto=0)
{	
	if (!$kdgrp || !$product)
		return -1;
	$preis=0;
	$endKunden_arr = explode(";",$GLOBALS['einstellungen']->mappingEndkunde);
	if ($endKunden_arr[0]>=0 && strlen($endKunden_arr[0])>0)
	{
		$preise = eS_execute_query("select product_price from ".DBPVM."product_price where price_quantity_end=0 and shopper_group_id=".$kdgrp." and product_id=".$product->product_id,1);
		$preis=$preise->product_price;
	}
	
	if ($brutto)
	{
		$tax = get_tax($product->product_tax_id);
		$preis=$preis+$preis*$tax;
	}
	
	return $preis;
}

function setEinstellungen($einstellungen)
{
	eS_execute_query("delete from jtlwawi_einstellungen where vendor_id=".VENDOR_ID,3);
	$arr=get_object_vars($einstellungen);
	$keys=array_keys($arr);
	for ($i=0;$i<count($keys);$i++)
	{
		eS_execute_query("insert into jtlwawi_einstellungen values (\"".$keys[$i]."\",\"".$einstellungen->$keys[$i]."\",".VENDOR_ID.")");
	}
}


?>