<?php
/**
 * jtlwawi_connector/dbeS/GetBestellungPos.php
 * JTL-Wawi Connector for VirtueMart
 * 
 * Es gelten die Nutzungs- und Lizenzhinweise unter http://www.jtl-software.de/jtlwawi.php
 * 
 * @author JTL-Software <thomas@jtl-software.de>
 * @copyright 2007, JTL-Software
 * @link http://jtl-software.de/jtlwawi.php
 * @version v1.0 / 24.06.07
*/
require_once("syncinclude.php");

$return=3;
if (auth())
{
	$return=5;
	if (intval($_POST['KeyBestellung']))
	{
		$return = 0;
		
		
		$shopper = eS_execute_query("select ".DBPVM."shopper_vendor_xref.shopper_group_id from ".DBPVM."shopper_vendor_xref, ".DBPVM."orders where ".DBPVM."orders.user_id=".DBPVM."shopper_vendor_xref.user_id and ".DBPVM."orders.vendor_id=".VENDOR_ID." and ".DBPVM."shopper_vendor_xref.vendor_id=".VENDOR_ID." and ".DBPVM."orders.order_id=".intval($_POST['KeyBestellung']),1);
		
		//hole orderposes
		$cur_query = eS_execute_query("select * from ".DBPVM."order_item where vendor_id=".VENDOR_ID." and order_id=".intval($_POST['KeyBestellung'])." order by order_item_id");
		while ($BestellungPos = mysql_fetch_object($cur_query))
		{
			//hol steuer
			$steuer = eS_execute_query("select ".DBPVM."tax_rate.tax_rate from ".DBPVM."tax_rate, ".DBPVM."product where ".DBPVM."tax_rate.tax_rate_id=".DBPVM."product.product_tax_id and ".DBPVM."product.product_id=".$BestellungPos->product_id,1);

			//hole etl aufpreise
			$aufpreis=0;
			if ($BestellungPos->product_attribute)
			{
				$varTeile = explode(";",$BestellungPos->product_attribute);
				foreach ($varTeile as $varTeil)
				{
					$tmp = explode(":",trim($varTeil));
					$aufpreis+=getAufpreis(trim($tmp[0]),trim($tmp[1]),$BestellungPos->product_id,$shopper->shopper_group_id)*(1+$steuer->tax_rate);
				}
			}
			
			//mappe bestellpos
			$kBestellPos = setMappingBestellPos($BestellungPos->order_item_id);
			echo(CSVkonform($kBestellPos).';');
			echo(CSVkonform(intval($_POST['KeyBestellung'])).';');
			echo(CSVkonform(getEsArtikel($BestellungPos->product_id)).';');
			echo(CSVkonform($BestellungPos->order_item_name).';');
			echo(CSVkonform($BestellungPos->product_final_price-$aufpreis).';');
			echo(CSVkonform($steuer->tax_rate*100).';');
			echo(CSVkonform($BestellungPos->product_quantity).';');
			echo("\n");
		}
		
		//letzte Positionen wie Versand, Mindermengenzuschlag, Rabatt, Kupon etc.
		$order = eS_execute_query("select * from ".DBPVM."orders where vendor_id=".VENDOR_ID." and ".DBPVM."orders.order_id=".intval($_POST['KeyBestellung']),1);
		
		if (strlen($order->ship_method_id)>1)
		{
			$tmp = explode("|",$order->ship_method_id);
			$preis=0;
			if ($tmp[3]>$preis)
				$preis=$tmp[3];
			else 
			{
				$preis=$order->order_shipping+$order->order_shipping_tax;
			}
			$steuersatz=0;
			if (intval($tmp[4])>0)
			{
				$steuer = eS_execute_query("select ".DBPVM."tax_rate.tax_rate from ".DBPVM."tax_rate, ".DBPVM."shipping_rate where ".DBPVM."tax_rate.tax_rate_id=".DBPVM."shipping_rate. shipping_rate_vat_id and ".DBPVM."shipping_rate.shipping_rate_id=".intval($tmp[4]),1);
				$steuersatz=$steuer->tax_rate*100;
			}
			$kBestellPos = setMappingBestellPos(0);
			echo(CSVkonform($kBestellPos).';');
			echo(CSVkonform(intval($_POST['KeyBestellung'])).';');
			echo(CSVkonform("0").';');
			echo(CSVkonform(unhtmlentities($tmp[1]." ".$tmp[2])).';');
			echo(CSVkonform($preis).';');
			echo(CSVkonform($steuersatz).';');
			echo(CSVkonform("1").';');
			echo("\n");
		}
		
		//gutschein
		if ($order->coupon_discount>0)
		{
			$steuersatz=0;
			$kBestellPos = setMappingBestellPos(0);
			echo(CSVkonform($kBestellPos).';');
			echo(CSVkonform(intval($_POST['KeyBestellung'])).';');
			echo(CSVkonform("0").';');
			echo(CSVkonform("Gutschein").';');
			echo(CSVkonform($order->coupon_discount*-1).';');
			echo(CSVkonform($steuersatz).';');
			echo(CSVkonform("1").';');
			echo("\n");
		}
		
		//gebhr / gutschrift
		if ($order->order_discount!=0)
		{
			$steuersatz=0;
			$pos="Gutschrift";
			if ($order->order_discount<0)
				$pos="Gebhr";
			$kBestellPos = setMappingBestellPos(0);
			echo(CSVkonform($kBestellPos).';');
			echo(CSVkonform(intval($_POST['KeyBestellung'])).';');
			echo(CSVkonform("0").';');
			echo(CSVkonform($pos).';');
			echo(CSVkonform($order->order_discount*-1).';');
			echo(CSVkonform($steuersatz).';');
			echo(CSVkonform("1").';');
			echo("\n");
		}
	}
}
mysql_close();
echo($return);
logge($return);
?>