<?php
/**
 * jtlwawi_connector/dbeS/getArtikel.php
 * JTL-Wawi Connector for VirtueMart
 * 
 * Es gelten die Nutzungs- und Lizenzhinweise unter http://www.jtl-software.de/jtlwawi.php
 * 
 * @author JTL-Software <thomas@jtl-software.de>
 * @copyright 2007, JTL-Software
 * @link http://jtl-software.de/jtlwawi.php
 * @version v1.0 / 24.06.07
*/
require_once("syncinclude.php");

$Response="";
$return = 3;
//Auth
if (auth())
{
	$einstellungen = getEinstellungen();
	
	$return = 0;
	//hole einen noch nicht versandten Artikel nach eS raus 
	$cur_query = eS_execute_query("select ".DBPVM."product.product_id from ".DBPVM."product LEFT JOIN jtlwawi_martikel ON ".DBPVM."product.product_id=jtlwawi_martikel.product_id and jtlwawi_martikel.vendor_id=".DBPVM."product.vendor_id where ".DBPVM."product.vendor_id=".VENDOR_ID." and jtlwawi_martikel.product_id is NULL limit 1");
	if ($product_id = mysql_fetch_object($cur_query))
	{		
		//hole product		
		$product = eS_execute_query("select * from ".DBPVM."product where product_id=".$product_id->product_id,1);
		if ($product->product_id>0)
		{	
			//hole Steuer
			$tax = get_tax($product->product_tax_id);
			$UVP = 0;
			
			//baue Response			
			$Response=CSVkonform("P").";".			
					CSVkonform($product->product_id).";".
					CSVkonform(substr(unhtmlentities($product->product_sku),0,29)).";".			
					CSVkonform(substr(unhtmlentities($product->product_name),0,255)).";".			
					CSVkonform(substr(unhtmlentities($product->product_desc),0,64000)).";".			
					CSVkonform(substr(unhtmlentities($product->product_s_desc),0,4000)).";".			
					CSVkonform(getPreis($product, $einstellungen->stdEndkunde,1)).";".
					CSVkonform(getPreis($product, $einstellungen->stdEndkunde)).";".			
					CSVkonform($UVP).";".			
					CSVkonform($tax*100).";".			
					CSVkonform("").";".			
					CSVkonform("Y").";".			
					CSVkonform($product->product_publish).";".			
					CSVkonform($product->product_in_stock).";".			
					CSVkonform($product->product_unit).";".			
					CSVkonform("1").";".			
					CSVkonform(unhtmlentities($product->products_ean)).";".			
					CSVkonform("").";".		
					CSVkonform(getPreis($product, $einstellungen->stdHaendlerkunde,1)).";".		
					CSVkonform(getPreis($product, $einstellungen->stdHaendlerkunde)).";".		
					CSVkonform($product->product_special).";".		
					CSVkonform("N").";".		
					CSVkonform("N").";".		
					CSVkonform($product->product_weight).";".		
					CSVkonform("N").";".		
					CSVkonform("N").";".		
					CSVkonform("N").";".		
					CSVkonform("N").";".		
					CSVkonform("0").";".		
					CSVkonform("0").";".		
					CSVkonform(unhtmlentities(getManufacturer($product->product_id))).";".		
					CSVkonform(get_bildURL($product)).";\n";		
					
			$Response.=get_cats($product->product_id);
			$Response.=get_variationen($product);
			$Response.=get_attribute($product);
			$Response.=get_staffelpreise($product->product_id,$einstellungen->stdEndkunde);
			$Response.=get_staffelpreise($product->product_id,$einstellungen->stdHaendlerkunde);
		}
	}
}
echo($return.";\n");
echo($Response);

function get_bildURL($product)
{
	$bilderUrls=IMAGEURL."product/".$product->product_full_image;
	//zustzliche bilder: $bilderUrls.=";".$url;
	return $bilderUrls;
}

function get_attribute($product)
{
	$attribute="";
	//Lieferstatus
	if ($product->product_discount_id>0)
	{
		//hole bezeichnung
		$sp = eS_execute_query("select * from ".DBPVM."product_discount where discount_id=".$product->product_discount_id,1);
		if ($sp->amount>0)
		{
			if ($sp->is_percent==1)
				$sp->amount.="%";
			//Attribut hinzufgen
			$attribute.=CSVkonform("T").";".			
				CSVkonform("Rabatt").";".
				CSVkonform($sp->amount).";\n";			
		}
	}
	if (strlen($product->product_url)>0)
	{
		//Attribut hinzufgen
		$attribute.=CSVkonform("T").";".			
			CSVkonform("URL").";".
			CSVkonform($product->product_url).";\n";
	}
	if (strlen($product->custom_attribute)>0)
	{
		//Attribut hinzufgen
		$attribute.=CSVkonform("T").";".			
			CSVkonform("Freifeldattribute").";".
			CSVkonform($product->custom_attribute).";\n";
	}
	if (strlen($product->product_availability)>0)
	{
		//Attribut hinzufgen
		$attribute.=CSVkonform("T").";".			
			CSVkonform("Lieferfrist").";".
			CSVkonform($product->product_availability).";\n";
	}
	if ($product->product_length>0)
	{
		//Attribut hinzufgen
		$attribute.=CSVkonform("T").";".			
			CSVkonform("Lnge").";".
			CSVkonform($product->product_length).";\n";
	}
	if ($product->product_width>0)
	{
		//Attribut hinzufgen
		$attribute.=CSVkonform("T").";".			
			CSVkonform("Breite").";".
			CSVkonform($product->product_width).";\n";
	}
	if ($product->product_height>0)
	{
		//Attribut hinzufgen
		$attribute.=CSVkonform("T").";".			
			CSVkonform("Hhe").";".
			CSVkonform($product->product_height).";\n";
	}
	if (strlen($product->product_lwh_uom)>0)
	{
		//Attribut hinzufgen
		$attribute.=CSVkonform("T").";".			
			CSVkonform("Lngenma").";".
			CSVkonform($product->product_lwh_uom).";\n";
	}
	if (strlen($product->product_weight_uom)>0)
	{
		//Attribut hinzufgen
		$attribute.=CSVkonform("T").";".			
			CSVkonform("Gewichtsma").";".
			CSVkonform($product->product_weight_uom).";\n";
	}
	if ($product->product_packaging>0)
	{
		$uip=intval($product->product_packaging/65536);
		$uib=$product->product_packaging%65536;
		//Attribut hinzufgen
		$attribute.=CSVkonform("T").";".			
			CSVkonform("VPE").";".
			CSVkonform($uib.",".$uip).";\n";
	}
	return $attribute;
}

function get_variationen($product)
{
	$variationen="";
	//existieren Variationen zu diesem Artikel?
	if ($product->attribute)
	{
		$varBlock=explode(";",$product->attribute);
		if (is_array($varBlock))
		{
			foreach ($varBlock as $o => $varBlockI)
			{
				$varEinzeln=explode(",",trim($varBlockI));
				if ($varEinzeln[0] && $varEinzeln[1])
				{
					foreach ($varEinzeln as $i => $var)
					{
						$attribute_id=0;
						$var=trim($var);
						$varGanz=$var;
						if ($i==0) //variation
						{							
							//varMapping
							unset($attribute_id);
							$attribute_id=setPreVariation($var, $product->product_id);
							$variationen.=CSVkonform("V").";".			
								CSVkonform($attribute_id).";".
								CSVkonform($var).";".					
								CSVkonform("Y").";".
								CSVkonform($o+1).";\n";
						}	
						else //varWerte
						{
							$preis=0;
							//schau, ob es aufpreise gibt
							if ($var{strlen($var)-1}=="]")
							{								
								$tmp = explode("[",$var);
								$var=$tmp[0];
								$preisBlock = str_replace("]","",$tmp[1]);
								if ($preisBlock{0}=="+")
								{
									$preis=str_replace("+","",$preisBlock);
								}
								elseif ($preisBlock{0}=="-")
								{
									$preis=str_replace("-","",$preisBlock);
									$preis*=-1;
								}
								elseif ($preisBlock{0}=="=")
								{
									$preis=str_replace("=","",$preisBlock);
									$preis=$preis-getPreis($product, $GLOBALS['einstellungen']->stdEndkunde);
								}
							}
							unset($attribute_value_id);
							$attribute_value_id=setPreVariationswert($var, $product->product_id, $attribute_id, $varGanz);
							
							$tax = get_tax($product->product_tax_id);
							$preisBrutto=$preis+$preis*$tax;
							
							$variationen.=CSVkonform("W").";".			
								CSVkonform($attribute_value_id).";".
								CSVkonform($attribute_value_id).";".
								CSVkonform($var).";".
								CSVkonform($preisBrutto).";".
								CSVkonform($preis).";".
								CSVkonform(0).";".
								CSVkonform("").";".
								CSVkonform($i).";".
								CSVkonform(0).";\n";
						}
					}
				}
			}
		}
		
	}
	return $variationen;
}

function get_staffelpreise($product_id, $kdgrp)
{
	if (!$kdgrp || !$product_id)
		return "";
	$staffel="";
	$anzahl = "";
	$preise = "";
	$anzahlStaffelpreise=0;
	
	if ($staffelpreiseDa)
	{
		//existieren Staffelprese fr diesen Artikel?
		$cur_query = eS_execute_query("select * from ".DBPVM."product_price where product_id=".$product_id." and price_quantity_start>0 and shopper_group_id=".$kdgrp." order by price_quantity_start asc limit 5");
		while ($staffelpreise = mysql_fetch_object($cur_query))
		{
			$anzahlStaffelpreise++;
			$anzahl.=";".CSVkonform($staffelpreise->price_quantity_start);
			$preise.=";".CSVkonform($staffelpreise->product_price);
		}
		if (strlen($anzahl)>0)
		{
			$staffel=CSVkonform("SH");
			if ($endkunde)
				$staffel=CSVkonform("SP");
			$staffel.=$anzahl;
			for ($i=0;$i<5-$anzahlStaffelpreise;$i++)
				$staffel.=";".CSVkonform("0");	
			$staffel.=$preise;
			for ($i=0;$i<5-$anzahlStaffelpreise;$i++)
				$staffel.=";".CSVkonform("0");	
			$staffel.=";\n";	
		}
	}
	return $staffel;
}

//get categroies 
function get_cats($product_id)
{
	$res ="";
	//get cat_id
	$glob_cat_query = eS_execute_query("select * from ".DBPVM."product_category_xref where product_id=".$product_id,3);
	while ($act_cat = mysql_fetch_object($glob_cat_query))
	{
		$catArr = array();
		$cur_cat_id = $act_cat->category_id;
		$current_cat;
		if ($cur_cat_id>0)
		{
			$current_cat = eS_execute_query("select * from ".DBPVM."category where category_id=".$cur_cat_id,1);
			$current_catExt = eS_execute_query("select * from ".DBPVM."category_xref where  category_child_id=".$cur_cat_id,1);
			$current_cat->parent_id=$current_catExt->category_parent_id;
			array_push($catArr,$cur_cat_id);
		}
		
		while ($current_cat->parent_id>0)
		{
			$cur_cat_id = $current_cat->parent_id;
			$current_cat = eS_execute_query("select * from ".DBPVM."category where category_id=".$cur_cat_id,1);
			$current_catExt = eS_execute_query("select * from ".DBPVM."category_xref where  category_child_id=".$cur_cat_id,1);
			$current_cat->parent_id=$current_catExt->category_parent_id;
			array_push($catArr,$cur_cat_id);		
		}
		$cnt = count($catArr);
		for ($i=0;$i<$cnt;$i++)
		{
			$vor="UK";
			if ($i==0)
				$vor="K";
			$catId = array_pop($catArr);
			$current_cat = eS_execute_query("select * from ".DBPVM."category where category_id=".$catId,1);

			$res.=CSVkonform($vor).";".			
				CSVkonform(unhtmlentities($current_cat->category_name)).";".
				CSVkonform(substr(unhtmlentities($current_cat->category_description),0,64000)).";".
				CSVkonform($catId).";".
				CSVkonform($current_cat->category_publish).";".
				CSVkonform(gibPic($current_cat->category_full_image)).";".
				CSVkonform($current_cat->list_order).";\n";
		}
	}
	if ($res=="")
		$res.=CSVkonform("K").";".			
			CSVkonform("Top").";".
			CSVkonform("Wurzelkategorie").";".
			CSVkonform(0).";".
			CSVkonform(0).";;".
			CSVkonform(0).";\n";
	return $res;
}

function gibPic($img)
{
	$picURL="";
	if (is_writeable(IMAGEPATH))
	{
		if (!file_exists(IMAGEPATH."jtlwawi_tmp"))
			mkdir (IMAGEPATH."jtlwawi_tmp");		
	}
	
	if (preg_match("#gif#i",substr($img,strlen($img)-3)) && file_exists(IMAGEPATH."jtlwawi_tmp"))
	{
		if(function_exists("ImageCreateFromGIF"))
		{
			$im = @ImageCreateFromGIF (IMAGEPATH."category/".$img);
			if ($im)
			{
				imagejpeg($im,IMAGEPATH."jtlwawi_tmp/".$catId.".jpg");
				if (file_exists(IMAGEPATH."jtlwawi_tmp/".$catId.".jpg"))
				{
					$picURL=IMAGEURL."jtlwawi_tmp/".$catId.".jpg";
				}
			}
		}
	}
	elseif (preg_match("#png#i",substr($img,strlen($img)-3)) && file_exists(IMAGEPATH."jtlwawi_tmp"))
	{
		if(function_exists("ImageCreateFromPNG"))
		{
			$im = @ImageCreateFromPNG (IMAGEPATH."category/".$img);
			if ($im)
			{
				imagejpeg($im,IMAGEPATH."jtlwawi_tmp/".$catId.".jpg");
				if (file_exists(IMAGEPATH."jtlwawi_tmp/".$catId.".jpg"))
				{
					$picURL=IMAGEURL."jtlwawi_tmp/".$catId.".jpg";
				}
			}
		}
	}
	else
	{
		$picURL=IMAGEURL."category/".$img;
	}
	return $picURL;
}

//get hersteller
function getManufacturer($product_id)
{
	if (!$product_id)
		return "";
	$mf = eS_execute_query("SELECT * FROM ".DBPVM."product_mf_xref, ".DBPVM."manufacturer WHERE ".DBPVM."manufacturer.manufacturer_id=".DBPVM."product_mf_xref.manufacturer_id and ".DBPVM."product_mf_xref.product_id=".$product_id,1);
	return $mf->mf_name;
}

?>