<?php
/**
 * jtlwawi_connector/install/index.php
 * JTL-Wawi Connector for VirtueMart
 * 
 * Es gelten die Nutzungs- und Lizenzhinweise unter http://www.jtl-software.de/jtlwawi.php
 * 
 * @author JTL-Software <thomas@jtl-software.de>
 * @copyright 2007, JTL-Software
 * @link http://jtl-software.de/jtlwawi.php
 * @version v1.0 / 24.06.07
*/
require_once("../dbeS/syncinclude.php");
zeigeKopf();
if (schritt1EingabenVollstaendig())
	installiere();
else
	installSchritt1();

zeigeFuss();



function zeigeKopf()
{
	echo('
<html>
	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8559-1">
		<meta http-equiv="language" content="deutsch, de">
		<meta name="author" content="JTL-Software, www.jtl-software.de">
		<title>JTL-Wawi Connector fr XT-Commerce Installation</title>
		<link rel="stylesheet" type="text/css" href="../admin/jtlwawiConnectorAdmin.css">
	</head>
	<body>
	<center>
	<table cellspacing="0" cellpadding="0" width="770">
		<tr>
			<td><img src="../gfx/jtlwawi_Connector_head_VM.jpg"></td>
		</tr>
		<tr>
			<td valign="top">
				<table cellspacing="0" cellpadding="0" width="100%">
					<tr>

	');
}

function zeigeFuss()
{
	echo('
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td bgcolor="#542A11" height="48" align="center"><span class="small" style="color:#ffffff">&copy; 2004-2007 JTL-Software</span></td>
		</tr>
	</table>
	<br>
	<a href="http://www.jtl-software.de/jtlwawi.php"><img src="../gfx/powered_by_jtlwawi.png"></a>
	</center>
	</body>
</html>
	');
}

function parse_mysql_dump($url) {
	$file_content = file($url);
	$errors="";
	//print_r($file_content);
	$query = "";
	foreach($file_content as $i => $sql_line) {
		$tsl = trim($sql_line);
		if (($sql_line != "") && (substr($tsl, 0, 2) != "--") && (substr($tsl, 0, 1) != "#")) {
			$query .= $sql_line;
			if(preg_match("/;\s*$/", $sql_line)) {
				$result = mysql_query($query);
				if (!$result) $errors.="<br>".mysql_error()." Nr: ".mysql_errno()." in Zeile ".$i."<br>".$query."<br>";
					$query = "";
			}
		}
	}
	return $errors;
}

function installSchritt1()
{
	//hole vendor
	$vendor = eS_execute_query("select * from ".DBPVM."vendor where vendor_id=".VENDOR_ID,1);
	
	//hole order_stati
	$order_stati = eS_execute_query("select * from ".DBPVM."order_status where vendor_id=".VENDOR_ID." order by list_order",2);
	//hole kundengruppen
	$shopper_groups = eS_execute_query("select * from ".DBPVM."shopper_group where vendor_id=".VENDOR_ID,2);
	$einstellungen;
	
	$mappingEndkunde_arr = array();
	$mappingHaendlerkunde_arr = array();
	
	//whrung vorauswahl
	if (!$einstellungen->waehrung)
		$einstellungen->waehrung=$vendor->vendor_currency;
	if (!$einstellungen->cat_browsepage)
		$einstellungen->cat_browsepage="browse_1";
	if (!$einstellungen->products_per_row)
		$einstellungen->products_per_row=2;
	
	//Warnung anzeigen
	$warnung="";
	if (!$einstellungen->mappingEndkunde)
		$warnung="<h2 style=\"color:#ff0000;\">Es muss mindestens eine EndKundengruppe von JTL-Wawi auf eine VirtueMart Kundengruppe gemappt werden - sonst werden keine Preise importiert!</h2>";
	
	srand();
	$syncuser = generatePW(8);
	sleep(1);
	$syncpass = generatePW(8);
		
	echo('
						<td bgcolor="#ffffff" style="border-color:#222222; border-width:1px; border-style:solid; border-top-width:0px; border-bottom-width:0px; border-left-width:0px;" valign="top" align="center" height="400"><br>
							<table cellspacing="0" cellpadding="0" width="96%">
								<tr><td class="content_header" align="center"><h3>Installation vom JTL-Wawi Connector fr VirtueMart</h3></td></tr>
								<tr><td class="content" align="center"><br>
										Fr den reibungslosen Im-/ und Export von Daten zwischen <a href="http://www.jtl-software.de">JTL-Wawi</a> und Ihrem Shop, mssen einige Einstellungen als Standard gesetzt sein.<br><br>
										Bitte erstellen Sie ein Shopdatenbankbackup, bevor Sie den ersten Abgleich mit JTL-Wawi durchfhren.
										<table cellspacing="0" cellpadding="0" width="580">
											<tr>
												<td class="unter_content_header">&nbsp;<b>Einstellungen</b></td>
											</tr>
											<tr>
												<td class="content" align="center">
													Hilfe zu den einzelnen Einstellungmglichkeiten finden Sie unter <a href="http://www.jtl-software.de/jtlwawi_connector.php" target="_blank">JTL-Wawi Connector Konfigurationshilfe</a>.<br>	
													Diese Konfigurationsseite knnen Sie spter im laufenden Betrieb erneut aufrufen und evtl. nderungen vornehmen. Die URL zu der Administrationsseite wird Ihnen nach der Installation angezeigt.
													<form action="index.php" method="post" name="inst">
													<input type="hidden" name="inst" value="1">
													<table cellspacing="0" cellpadding="10" width="100%">
														<tr>
															<td><b>Standardiefertermin</b></td><td><input type="text" name="liefertermin" size="50" class="konfig" value="'.$einstellungen->liefertermin.'"></td>
														</tr>
														<tr>
															<td><b>Standardwhrung</b></td><td><input type="text" name="waehrung" size="50" class="konfig" value="'.$einstellungen->waehrung.'"></td>
														</tr>
														<tr>
															<td>Bestellstatusnderungen</td><td>&nbsp;</td>
														</tr>
														<tr>
															<td><b>Sobald Bestellung erfolgreich in JTL-Wawi bernommen wird, Status setzen auf:</b></td><td><select name="StatusAbgeholt"><option value="0">Status nicht ndern</option>
	');
	foreach ($order_stati as $order_status)
	{
		echo('<option value="'.$order_status->order_status_code.'" ');if ($order_status->order_status_code==$einstellungen->StatusAbgeholt) echo('selected'); echo('>'.$order_status->order_status_name.'</option>');
	}
	echo('
															</select>														
															</td>
														</tr>
														<tr>
															<td><b>Sobald Bestellung in JTL-Wawi versandt wird, Status setzen auf</b></td><td><select name="StatusVersendet"><option value="0">Status nicht ndern</option>
	');
	foreach ($order_stati as $order_status)
	{
		echo('<option value="'.$order_status->order_status_code.'" ');if ($order_status->order_status_code==$einstellungen->StatusVersendet) echo('selected'); echo('>'.$order_status->order_status_name.'</option>');
	}
	echo('
															</select>														
															</td>
														</tr>
													</table><br>
													JTL-Wawi kennt nur die Kundengruppen Endkunde und Hndlerkunde. Weisen Sie diesen Kundengruppen Ihre Shop-Kundengruppen zu - dies ist fr die korrekte Preiszuordnung unerlsslich. Vergeben Sie nicht Ihre Kundengruppen doppelt.<br>
													<table cellspacing="0" cellpadding="10" width="100%">
														<tr>
															<td valign="top"><b>JTL-Wawi Endkunde</b></td><td>'.$warnung.'
	');
	foreach ($shopper_groups as $shopper_group)
	{
		echo('<input type="checkbox" name="endkunde[]" value="'.$shopper_group->shopper_group_id.'"');if (in_array($shopper_group->shopper_group_id,$mappingEndkunde_arr)) echo('checked'); echo('> '.$shopper_group->shopper_group_name.'<br>');
	}														
	echo('
															</td>
														</tr>
														<tr>
															<td valign="top"><b>JTL-Wawi Hndlerkunde</b></td><td>
	');
	foreach ($shopper_groups as $shopper_group)
	{
		echo('<input type="checkbox" name="haendlerkunde[]" value="'.$shopper_group->shopper_group_id.'"');if (in_array($shopper_group->shopper_group_id,$mappingHaendlerkunde_arr)) echo('checked'); echo('> '.$shopper_group->shopper_group_name.'<br>');
	}														
	echo('
															</td>
														</tr>
													</table><br>
													Standardeinstellungen fr Kategorien, die ber JTL-Wawi eingestellt werden:
													<table cellspacing="0" cellpadding="10" width="100%">
														<tr>
															<td><b>Kategorievorlage (category_browsepage):</b></td><td><input type="text" name="cat_browsepage" size="50" class="konfig" value="'.$einstellungen->cat_browsepage.'"></td>
														</tr>
														<tr>
															<td><b># Artikel nebeneinander (products_per_row):</b></td><td><input type="text" name="products_per_row" size="50" class="konfig" value="'.$einstellungen->products_per_row.'"></td>
														</tr>
														<tr>
															<td><b>Kategorievorlage (category_flypage):</b></td><td><input type="text" name="category_flypage" size="50" class="konfig" value="'.$einstellungen->category_flypage.'"></td>
														</tr>
														<tr>
															<td colspan="2" valign="top"><b>Bestellungen --> JTL-Wawi</b><br>Folgende noch nicht nach JTL-Wawi versandte Bestellungen werden hiermit als "bereits zu JTL-Wawi versandt" markiert und bei einem Webshopabgleich nicht nach JTL-Wawi geholt:<br>
															<br><b>Beispiel: </b>Sie mchten Ihre alten, bereits versandten und abgeschlossenen Auftrge und Kundendaten nicht in JTL-Wawi importieren, so machen Sie einen entsprechenden Haken bei diesem Bestellstatus (meist: Versandt / shipped).<br><br>
															Bitte beachten Sie, dass jede Bestellung, die in JTL-Wawi automatisch importiert wird, eine neue Bestellung fr Wawi ist. Daher werden bei allen - auch bei bereits abgeschlossenen Bestellauftrgen - die Stati so gesetzt wie Sie es weiter oben bei "Sobald Bestellung erfolgreich in JTL-Wawi bernommen wird, Status setzen auf:" eingestellt haben. Sollten Sie viele ltere Bestellungen in JTL-Wawi bernehmen wollen, so setzen Sie unter "Sobald Bestellung erfolgreich in JTL-Wawi bernommen wird, Status setzen auf:" den Status auf "nicht verndern" und fhren Sie in JTL-Wawi den ersten Abgleich mit dem Webshop durch. Erst nachdem alle gewnschten Bestellungen in JTL-Wawi importiert wurden, knnen Sie die Einstellung unter "Sobald Bestellung erfolgreich in JTL-Wawi bernommen wird, Status setzen auf:" so setzen, wie Sie es im laufenden Betrieb wnschen. 
															
															</td>
														</tr>
														<tr>
															<td colspan="2" valign="top" align="center">															
		');
	foreach ($order_stati as $order_status)	
	{
		echo('<input type="checkbox" name="bestellungen_bestellt[]" value="'.$order_status->order_status_code.'">'.$order_status->order_status_name);
	}
	echo('
															</td>
														</tr>
													</table><br>
												</td>
											</tr>
										</table><br>
										<table cellspacing="0" cellpadding="0" width="580">
											<tr>
												<td class="unter_content_header">&nbsp;<b>Synchronsations - Benutzerdaten</b></td>
											</tr>
											<tr>
												<td class="content">													
													Fr die Synchronisation zwischen JTL-Wawi und diesem wird ein Synchronisationsbenutzer bentigt. Bitte <b>notieren Sie sich</b> unbedingt <b>diese Angaben</b> und setzen sie einen starken kryptischen Benutzernamen und Passwort - oder bernehmen Sie die zufllig generierten Vorgaben. Diese Angaben werden einmalig in den JTL-Wawi Einstellungen eingetragen.
													<br><br><br>
													<center>
													<table cellspacing="0" cellpadding="10" width="70%" style="border-width:1px;border-color:#222222;border-style:solid;">
													<tr>
														<td><b>Sync-Benutzername</b></td><td><input type="text" name="syncuser" size="20" class="login" value="'.$syncuser.'"></td>
													</tr>
													<tr>
														<td><b>Sync-Passwort</b></td><td><input type="text" name="syncpass" size="20" class="login" value="'.$syncpass.'"></td>
													</tr>
													</table>
													<br><br>
													'.$hinweis.'
													<input type="submit" value="Installation starten">
													</form>
													</center>
												</td>
											</tr>
										</table>
								</td></tr>
							</table><br>
						</td>
	');
}

function schritt1EingabenVollstaendig()
{
	if (strlen($_POST["syncuser"])>0 && strlen($_POST["syncpass"])>0)
		return 1;
	return 0;
}

function installiere()
{
	$hinweis = parse_mysql_dump("jtlwawi_connector_DB.sql");
	//inserte syncuser
	if (!mysql_query("insert into jtlwawi_sync values (\"".$_POST['syncuser']."\",\"".$_POST['syncpass']."\",".VENDOR_ID.")")) $hinweis.="<br>".mysql_error()." Nr: ".mysql_errno();
	
	//Bestellungen gesendet markeiren
	$qry_teil="";
	if (is_array($_POST['bestellungen_bestellt']))
	{
		foreach ($_POST['bestellungen_bestellt'] as $i => $status)
		{
			if ($i!=0)
				$qry_teil.=" or order_status=\"".$status."\"";
			else
				$qry_teil.=" order_status=\"".$status."\"";
		}
	}
	if (strlen($qry_teil)>1)
	{
		$best_query = eS_execute_query("select order_id from ".DBPVM."orders where $qry_teil order by order_status");
		while ($orderkey = mysql_fetch_row($best_query))
		{
			if ($orderkey[0]>0)
			{
				//schaue, ob nicht schon markiert
				$einzel_query = eS_execute_query("select order_id from jtlwawi_sentorders where vendor_id=".VENDOR_ID." and order_id=".$orderkey[0]);
				$oid = mysql_fetch_row($einzel_query);
				if (!$oid[0])
					eS_execute_query("insert into jtlwawi_sentorders (order_id,vendor_id) values (".$orderkey[0].",".VENDOR_ID.")");
			}
		}
	}
	$einstellungen->mappingEndkunde="";
	$einstellungen->mappingHaendlerkunde="";
	if (is_array($_POST['endkunde']))
		$einstellungen->mappingEndkunde=implode(";",$_POST['endkunde']);
	if (is_array($_POST['haendlerkunde']))
		$einstellungen->mappingHaendlerkunde=implode(";",$_POST['haendlerkunde']);
	$einstellungen->liefertermin = $_POST['liefertermin'];
	$einstellungen->StatusAbgeholt = $_POST['StatusAbgeholt'];
	$einstellungen->StatusVersendet = $_POST['StatusVersendet'];
	$einstellungen->cat_browsepage = $_POST['cat_browsepage'];
	$einstellungen->products_per_row = $_POST['products_per_row'];
	$einstellungen->category_flypage = $_POST['category_flypage'];
	$einstellungen->waehrung = $_POST['waehrung'];
	
	setEinstellungen($einstellungen);

	if (strlen($hinweis)>0)
	{
		echo('
							<td bgcolor="#ffffff" style="border-color:#222222; border-width:1px; border-style:solid; border-top-width:0px; border-bottom-width:0px;" valign="top" align="center"><br>
								<table cellspacing="0" cellpadding="0" width="96%">
									<tr><td class="content_header" align="center"><h3>JTL-Wawi Connector Datenbankeinrichtung fehlgeschlagen</h3></td></tr>
									<tr><td class="content" align="center"><br>
											<table cellspacing="0" cellpadding="0" width="580">
												<tr>
													<td class="unter_content_header">&nbsp;<b>Bei der Datenbankeinrichtung sind folgende Fehler aufgetreten</b></td>
												</tr>
												<tr>
													<td class="content">
	'.$hinweis.'<br><br><br>Lsungen sollten Sie hier finden: <a href="http://www.jtl-software.de/jtlwawi_connector.php">JTL-Wawi Connector</a>
													</td>
												</tr>
											</table>
									</td></tr>
								</table><br>
							</td>
		');
	}
	else
	{
		//hole webserver
		$url= "http://".$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME'];
		echo('
							<td bgcolor="#ffffff" style="border-color:#222222; border-width:1px; border-style:solid; border-top-width:0px; border-bottom-width:0px;" valign="top" align="center"><br>
								<table cellspacing="0" cellpadding="0" width="96%">
									<tr><td class="content_header" align="center"><h3>JTL-Wawi Connector Installation erfolgreich abgeschlossen</h3></td></tr>
									<tr><td class="content" align="center"><br>
											<table cellspacing="0" cellpadding="0" width="580">
												<tr>
													<td class="unter_content_header">&nbsp;<b>Die Datenbank fr JTL-Wawi Connector wurde aufgesetzt</b></td>
												</tr>
												<tr>
													<td class="content">
														Die Installation ist serverseitig soweit abgeschlossen.<br><br>
														Sie mssen nun JTL-Wawi im Men Einstellungen -> Shop-Einstellungen konfigurieren.<br><br>
														Folgende Einstellungen mssen Sie in JTL-Wawi eintragen:<br><br>
														<table width="95%">
														<tr><td><b>API-KEY</b>: </td><td>JTL-Wawi Connector</td></tr>
														<tr><td><b>Web-Server</b>: </td><td>'.substr($url,0,strlen($url)-18).'</td></tr>
														<tr><td><b>Web-Benutzer</b>: </td><td>'.$_POST['syncuser'].'</td></tr>
														<tr><td><b>Passwort</b>: </td><td>'.$_POST['syncpass'].'</td></tr>
														</table><br><br>
														Setzen Sie einen Haken bei "Bilder per HTTP versenden".<br>
														
														<br><br>
														Die Konfiguration des Connector knnen Sie unter dieser Adresse erreichen: <b>'.substr($url,0,strlen($url)-18).'/admin</b>. Als Zugangsdaten gelten die oben dargestellten.
														
														<br><br>
														Bei Fragen und Anregungen laden wir Sie herzlich in unser Forum ein: <a href="http://jtl-software.de/forum/index.php">JTL-Software Forum</a>.
														<br><br>
														Wir wnschen Ihnen viel Erfolg mit Ihrem Shop!
													</td>
												</tr>
											</table>
									</td></tr>
								</table><br>
							</td>
		');
	}
}

function generatePW($length=8)
{
	$dummy= array_merge(range('0', '9'), range('a', 'z'), range('A', 'Z'));
	mt_srand((double)microtime()*1000000);
	for ($i = 1; $i <= (count($dummy)*2); $i++)
	{
		$swap= mt_rand(0,count($dummy)-1);
		$tmp= $dummy[$swap];
		$dummy[$swap]= $dummy[0];
		$dummy[0]= $tmp;
	}
	return substr(implode('',$dummy),0,$length);
}
?>